/*
 * File:	wb_messg.h
 * Purpose:	Declares panel items (controls/widgets)
 * Author:	Julian Smart
 * Created:	1993
 * Updated:	
 * Copyright:	(c) 1993, AIAI, University of Edinburgh
 */

/* sccsid[] = "@(#)wb_messg.h	1.2 5/9/94" */

#ifndef wxb_messgh
#define wxb_messgh

#ifdef __GNUG__
#pragma interface
#endif

#include "common.h"
#include "wx_panel.h"
#include "wx_item.h"

#ifdef IN_CPROTO
typedef       void    *wxbMessage ;
#else

extern Constdata char *wxMessageNameStr;

// Message item
class wxbMessage: public wxItem
{
 protected:
  Bool isBitmap;
 public:
  wxbMessage(void);

  wxbMessage(wxPanel *panel, Const char *message, int x = -1, int y = -1, long style = 0,
             Constdata char *name = wxMessageNameStr);
#if USE_BITMAP_MESSAGE
  wxbMessage(wxPanel *panel, wxBitmap *image, int x = -1, int y = -1, long style = 0,
             Constdata char *name = wxMessageNameStr);
#endif
  ~wxbMessage(void);
  
  virtual Bool IsBitmap(void) { return isBitmap; }
  virtual wxBitmap *GetBitmap(void) = 0;
};

#endif // IN_CPROTO
#endif // wxb_messgh
