/*										-*-c++-*-
 * File:    wx_choic.h
 * Purpose:    Choice panel item
 * Author:    Julian Smart
 * Created:    1993
 * Updated:    
 * Copyright:    (c) 1993, AIAI, University of Edinburgh
 */

/* sccsid[] = "@(#)wx_choic.h    1.2 5/9/94" */

#ifndef wx_choich
#define wx_choich

#include "wb_choic.h"

#ifdef IN_CPROTO
typedef       void    *wxChoice ;
#else

extern Constdata char *wxChoiceNameStr;

// Choice item
class wxChoice: public wxbChoice
{
    DECLARE_DYNAMIC_CLASS(wxChoice)

public:

    wxChoice(void);
    wxChoice(wxPanel *panel, wxFunction func, const char *Title,
	     int x = -1, int y = -1, int width = -1, int height = -1,
	     int N = 0, char **Choices = NULL,
	     long style = 0, const char *name = wxChoiceNameStr);
    ~wxChoice(void);

    Bool Create(wxPanel *panel, wxFunction func, const char *Title,
		int x = -1, int y = -1, int width = -1, int height = -1,
		int N = 0, char **Choices = NULL,
		long style = 0, const char *name = wxChoiceNameStr);
    void Append(char *Item);
    void Clear(void);
    int GetSelection(void);
    void SetSelection(int n);
    int FindString(char *s);
    char *GetString(int n);
    void GetAutoSize(int *cx, int *cy);
    BOOL OS2Control(WORD param, WORD id);

    inline void SetColumns(int WXUNUSED(n) = 1 ) { /* No effect */ } ;
    inline int GetColumns(void) { return 1 ; };
};

#endif // IN_CPROTO
#endif // wx_choich
