/* -*-c++-*-
 * File:    wx_frame.h
 * Purpose:    wxFrame declaration
 * Author:    Julian Smart
 * Created:    1993
 * Updated:    
 * Copyright:    (c) 1993, AIAI, University of Edinburgh
 */

/* sccsid[] = "@(#)wx_frame.h    1.2 5/9/94" */

#ifndef wx_frameh
#define wx_frameh

#include "wb_frame.h"

#ifdef IN_CPROTO
typedef       void    *wxFrame ;
#else

extern Constdata char *wxFrameNameStr;
extern Constdata char *wxStatusLineNameStr;

class wxFrame: public wxbFrame
{
  DECLARE_DYNAMIC_CLASS(wxFrame)

 public:
  Bool wx_iconized;

  wxFrame(void);
  wxFrame(wxFrame *parent, const char *title,
          int x=-1, int y=-1, int width=-1, int height=-1,
          long style = wxSDI | wxDEFAULT_FRAME, const char *name = wxFrameNameStr);

  ~wxFrame(void);

  Bool Create(wxFrame *parent, const char *title,
          int x=-1, int y=-1, int width=-1, int height=-1,
          long style = wxSDI | wxDEFAULT_FRAME, const char *name = wxFrameNameStr);

  void SetClientSize(int width, int height);
  void GetClientSize(int *width, int *height);

  void GetSize(int *width, int *height);
  void GetPosition(int *x, int *y);
  void SetSize(int x, int y, int width, int height, int sizeFlags = wxSIZE_AUTO);
  Bool Show(Bool show);

  // Set menu bar
  void SetMenuBar(wxMenuBar *menu_bar);

  // Set title
  void SetTitle(const char *title);
  char *GetTitle(void);

  // Set icon
  void SetIcon(wxIcon *icon);

  // Create status line
  void CreateStatusLine(int number=1, Constdata char *name = wxStatusLineNameStr);

  // Set status line text
  void SetStatusText(char *text, int number = 0);

  // Fit frame around subwindows
  void Fit(void);

  // Iconize
  virtual void Iconize(Bool iconize);
  virtual Bool Iconized(void);
  // Windos 3.x maximize/restore
  virtual void Maximize(Bool maximize);
  virtual void LoadAccelerators(ULONG resourceId);

  // Get the active MDI child window (Windows only)
  wxFrame *GetActiveChild(void);
  
  HWND GetWinMenu(void);
};

#endif // IN_CPROTO
#endif // wx_frameh
