/*											-*- c++ -*-
 * File:	wx_gauge.h
 * Purpose:	Gauge panel item
 * Author:	Julian Smart
 * Created:	1993
 * Updated:	
 * Copyright:	(c) 1993, AIAI, University of Edinburgh
 */

/* sccsid[] = "@(#)wx_gauge.h	1.2 5/9/94" */

#ifndef wx_gaugeh
#define wx_gaugeh

#include "wb_gauge.h"

#ifdef IN_CPROTO
typedef       void    *wxGauge;
#else

extern Constdata char *wxGaugeNameStr;

// Group box
class wxGauge: public wxbGauge
{
    DECLARE_DYNAMIC_CLASS(wxGauge)
private:
public:
    wxGauge(void);
    wxGauge(wxPanel *panel, const char *label, int range, int x = -1, int y = -1,
	    int width = -1, int height = -1, long style = 0, const char *name = wxGaugeNameStr);
    ~wxGauge(void);
    Bool Create(wxPanel *panel, const char *label, int range, int x=-1, int y=-1,
		int width=-1, int height=-1, long style=0, const char *name=wxGaugeNameStr);
/*
  void Command(wxCommandEvent& event);
  void ProcessCommand(wxCommandEvent& event);
  */
    void SetShadowWidth(int w);
    void SetBezelFace(int w);
    void SetRange(int r);
    void SetValue(int pos);
    void SetBackgroundColour(wxColour& col);

    int GetShadowWidth(void);
    int GetBezelFace(void);
    int GetRange(void);
    int GetValue(void);

    void SetButtonColour(wxColour *col);
    void SetBackgroundColour(wxColour *col);
};

#endif // IN_CPROTO
#endif // wx_gaugeh
