/* -*- c++ -*- 
 * File:	wx_itemp.h
 * Purpose:	Panel item private declarations
 * Author:	Julian Smart
 * Created:	1993
 * Updated:	April 1995
 * Copyright:	(c) 1995, AIAI, University of Edinburgh
 */

#ifndef wx_itemph
#define wx_itemph

/* When implementing a new item, be sure to:
 *
 * - add the item to the parent panel
 * - set window_parent to the parent
 * - NULL any extra child window pointers not created for this item
 *   (e.g. label control that wasn't needed)
 * - delete any extra child windows in the destructor (e.g. label control)
 * - implement GetSize and SetSize
 * - to find panel position if coordinates are (-1, -1), use GetPosition
 * - call AdvanceCursor after creation, for panel layout mechanism.
 *
 */

#include "wx_item.h"
#include "wx_privt.h"
#include "wx_utils.h"

/*
 * Decide what window classes we're going to use
 * for this combination of CTl3D/FAFA settings
 */
 
#define RADIO_SIZE       20

#define MEANING_CHARACTER '0'
#define DEFAULT_ITEM_WIDTH  200
#define DEFAULT_ITEM_HEIGHT 80
#define EDIT_CONTROL_FACTOR (15.0/10.0)
                                        // Scale font to get edit control height
// Generic subclass proc, for panel item moving/sizing and intercept
// EDIT control VK_RETURN messages
//extern LONG wxSubclassedGenericControlProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2);

// Find maximum size of window/rectangle
extern void wxFindMaxSize(HWND hwnd, wxRECTL *rect);

#if 0
// List of controls
#if !WXGARBAGE_COLLECTION_ON /* MATTHEW: GC */
extern wxList *wxControlHandleList;
#else
extern wxNonlockingHashTable *wxControlHandleList;
#endif
#endif

// List of scrollbar controls
extern wxList wxScrollBarList;
extern char *wxBuffer;
extern HAB wxhAb;

//wxItem *wxFindControlFromHandle(HWND hWnd);
//void wxAddControlHandle(HWND hWnd, wxItem *item);

#endif
