/*												-*- c++ -*-
 * File:    wx_rbox.h
 * Purpose:    Radio box panel item
 * Author:    Julian Smart
 * Created:    1993
 * Updated:    
 * Copyright:    (c) 1993, AIAI, University of Edinburgh
 */

/* sccsid[] = "@(#)wx_rbox.h    1.2 5/9/94" */

#ifndef wx_rboxh
#define wx_rboxh

#include "wb_rbox.h"

#ifdef IN_CPROTO
typedef       void    *wxRadioBox ;
#else

extern Constdata char *wxRadioBoxNameStr;

// List box item
class wxBitmap ;
class wxRadioBox: public wxbRadioBox
{
    DECLARE_DYNAMIC_CLASS(wxRadioBox)
public:
    int selected;
    HWND *hwndButtons;			// Pointer to array of window handles for the buttons
    int majorDim ;
    long style ;
    int *radioWidth ;  // for bitmaps
    int *radioHeight ;

    wxRadioBox(void);
    wxRadioBox(wxPanel *panel, wxFunction func, const char *Title,
	       int x = -1, int y = -1, int width = -1, int height = -1,
	       int N = 0, char **Choices = NULL,
	       int majorDim = 0, long style = wxHORIZONTAL, const char *name = wxRadioBoxNameStr);

    wxRadioBox(wxPanel *panel, wxFunction func, const char *Title,
	       int x = -1, int y = -1, int width = -1, int height = -1,
	       int N = 0, wxBitmap **Choices = NULL,
	       int majorDim = 0, long style = wxHORIZONTAL, const char *name = wxRadioBoxNameStr);
    ~wxRadioBox(void);

    Bool Create(wxPanel *panel, wxFunction func, const char *Title,
		int x = -1, int y = -1, int width =-1, int height = -1,
		int N = 0, char **Choices = NULL,
		int majorDim = 0, long style = wxHORIZONTAL, const char *name = wxRadioBoxNameStr);
    Bool Create(wxPanel *panel, wxFunction func, const char *Title,
		int x = -1, int y = -1, int width = -1, int height = -1,
		int N = 0, wxBitmap **Choices = NULL,
		int majorDim = 0, long style = wxHORIZONTAL, const char *name = wxRadioBoxNameStr);
             
    BOOL OS2Control(WORD param, ULONG id);

    int FindString(char *s);
    void SetSelection(int N);
    int GetSelection(void);
    char *GetString(int N);
//    void SetSize(int x, int y, int width, int height, int sizeFlags = wxSIZE_AUTO);
    void GetSize(int *x, int *y);
    void GetAutoSize(int *cx, int *cy);
    void PositionItem(int x, int y, int width, int height);
    void GetPosition(int *x, int *y);
    char *GetLabel(void);
    void SetLabel(char *label);
    void SetLabel(int item, const char *label) ;
    void SetLabel(int item, wxBitmap *bitmap) ;
    char *GetLabel(int item) ;
    Bool Show(Bool show);
    void SetFocus(void);
    void Enable(Bool enable);
    void Enable(int item, Bool enable);
    void Show(int item, Bool show) ;
    void SetLabelFont(wxFont *font);
    void SetButtonFont(wxFont *font);
    void SetBackgroundColour(wxColour& col);
    void SetButtonColour(wxColour& col);
};

#endif // IN_CPROTO
#endif // wx_rboxh



