/*												-*- C++ -*-
 * File:	wx_slidr.h
 * Purpose:	Slider
 * Author:	Julian Smart
 * Created:	1993
 * Updated:	
 * Copyright:	(c) 1993, AIAI, University of Edinburgh
 */

/* sccsid[] = "@(#)wx_slidr.h	1.2 5/9/94" */

#ifndef wx_slidrh
#define wx_slidrh

#include "wb_slidr.h"

#ifdef IN_CPROTO
typedef       void    *wxSlider ;
#else

extern Constdata char *wxSliderNameStr;

// Slider
class wxSlider: public wxbSlider
{
    DECLARE_DYNAMIC_CLASS(wxSlider)

public:
    HWND hwndStaticMin;
    HWND hwndStaticMax;
    HWND hwndEditValue;

    int s_min;
    int s_max;
    int page_size;

    wxSlider(void);
    wxSlider(wxPanel *panel, wxFunction func, const char *label, int value,
	     int min_value, int max_value, int width, int x = -1, int y = -1,
	     long style = wxHORIZONTAL, const char *name = wxSliderNameStr);
    ~wxSlider(void);

    Bool Create(wxPanel *panel, wxFunction func, const char *label, int value,
		int min_value, int max_value, int width, int x = -1, int y = -1,
		long style = wxHORIZONTAL, const char *name = wxSliderNameStr);
    virtual int GetValue(void);
    virtual void SetValue(int);
    void GetSize(int *x, int *y);
    void SetSize(int x, int y, int width, int height, int sizeFlags = wxSIZE_AUTO);
    void GetPosition(int *x, int *y);

    void SetRange(int minValue, int maxValue);
    void SetLabelColour(wxColour& col);
    void SetBackgroundColour(wxColour& col);

    int GetMin(void);
    int GetMax(void);
};

#endif // IN_CPROTO
#endif // wx_slidrh
