/*												-*- c++ -*-
 * File:    wx_txt.h
 * Purpose:    Text panel item
 * Author:    Julian Smart
 * Created:    1993
 * Updated:    
 * Copyright:    (c) 1993, AIAI, University of Edinburgh
 */

/* sccsid[] = "%W% %G%" */

#ifndef wx_txth
#define wx_txth

#include "wb_txt.h"

#ifdef IN_CPROTO
typedef       void    *wxText ;
#else

extern Constdata char *wxTextNameStr;
extern Constdata char *wxEmptyString;

// Single-line text item
class wxText: public wxbText
{
    DECLARE_DYNAMIC_CLASS(wxText)

public:

    wxText(void);
    wxText(wxPanel *panel, wxFunction func, const char *label, const char *value = wxEmptyString,
	   int x = -1, int y = -1, int width = -1, int height = -1,
	   long style = 0, const char *name = wxTextNameStr);
    ~wxText(void);

    Bool Create(wxPanel *panel, wxFunction func, const char *label, const char *value = wxEmptyString,
		int x = -1, int y = -1, int width = -1, int height = -1,
		long style = 0, const char *name = wxTextNameStr);
    char *GetValue(void);
    void SetValue(char *value);
    void GetAutoSize(int *cx, int *cy);
    void SetFocus(void);

    // Clipboard operations
    virtual void Copy(void);
    virtual void Cut(void);
    virtual void Paste(void);

    virtual void SetInsertionPoint(long pos);
    virtual void SetInsertionPointEnd(void);
    virtual long GetInsertionPoint(void);
    virtual long GetLastPosition(void);
    virtual void Replace(long from, long to, char *value);
    virtual void Remove(long from, long to);
    virtual void SetSelection(long from, long to);

    BOOL OS2Control(WORD param, ULONG id);

    void SetEditable(Bool editable);
};

#endif // IN_CPROTO
#endif // wx_txth
