/*
 * File:	wx_text.cc
 * Purpose:	wxTextWindow implementation
 * Author:	Julian Smart
 * Created:	1993
 * Updated:	August 1994
 * RCS_ID:      $Id: wx_text.cc,v 1.1 1994/08/14 21:59:17 edz Exp $
 * Copyright:	(c) 1993, AIAI, University of Edinburgh
 */


/* static const char sccsid[] = "%W% %G%"; */

#include "wx_privt.h"
#include "wx_list.h"
#include "wx_clipb.h"
#include "wx_text.h"
#include "wx_panel.h"
#include "wx_gdi.h"
#include "wx_utils.h"

#include <iostream.h>
#include <fstream.h>

#include <stdio.h>
#include <io.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <sys/stat.h>
#include <malloc.h>

extern char wxCanvasClassName[];

IMPLEMENT_DYNAMIC_CLASS(wxTextWindow, wxWindow)

wxTextWindow::wxTextWindow(void)
{
    file_name = NULL;
    handle = NULL;
    hwndTextWindow = NULLHANDLE;
//  oldTextProc = 0;

}

wxTextWindow::wxTextWindow(wxWindow *parent, int x, int y, int width, int height,
                           long style, const char *name):
  wxbTextWindow(parent, x, y, width, height, style, name)

{
  Create(parent, x, y, width, height, style, name);
}


//static PFNWP TextProc = NULL;
//static PFNWP OldTextProc = NULL;
wxList *wxTextWinList=NULL;
wxTextWindow *wxTextWinFromHandle(HWND hWnd)
{
  if (!wxTextWinList)
    return NULL;

  wxNode *node = wxTextWinList->Find((long)hWnd);
  if (!node)
    return NULL;
  return (wxTextWindow *)node->Data();
}
BOOL wxCDown,wxSDown;
WORD WX_CHAR,WX_KEYDOWN,WX_KEYUP;

#if 0
void wxTextWindow::Synch()
{
        QMSG current_msg;
        while(::PeekMessage(&current_msg,NULL,WX_KEYDOWN , WX_KEYUP, PM_REMOVE))
        {
                ::TranslateMessage(&current_msg);
                ::DispatchMessage(&current_msg);
        }
}
void wxTextWindow::Char(MPARAM mp1, BOOL isASCII)
{
        int id;
        Bool tempControlDown = FALSE;
        // If 1 -> 26, translate to CTRL plus a letter.
        id = mp1;
        if (isASCII)
        {
                /*if ((id > 0) && (id < 27))
                {
                        tempControlDown = TRUE;
                        id = id + 96;
                } */
        }
        else if ((id = wxCharCodeMSWToWX(MPARAM)) == 0)
                id = -1;
        if (id > -1)
        {
                wxKeyEvent event(wxEVENT_TYPE_CHAR);
                if (wxSDown)
                        event.shiftDown = TRUE;
                if (wxCDown || tempControlDown)
                        event.controlDown = TRUE;
                event.eventObject =(wxWindow *) this;
                event.keyCode = id;
                event.x=event.y=0;
                OnChar(event);
        }
        return ;
}
LRESULT wxTextProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
	wxTextWindow *wnd = wxTextWinFromHandle(hWnd);
	if (!wnd)
	  return FALSE;
	  
	if(message==WX_CHAR)
		return CallWindowProc(WNDPROCCAST wnd->oldTextProc, hWnd,WM_CHAR, wParam, lParam);
	if(message==WX_KEYDOWN)
		return CallWindowProc(WNDPROCCAST wnd->oldTextProc, hWnd,WM_KEYDOWN, wParam, lParam);
	if(message==WX_KEYUP)
		return CallWindowProc(WNDPROCCAST wnd->oldTextProc, hWnd,WM_KEYUP, wParam, lParam);
        if (wnd)
        {
                wnd->last_msg = msg;
                wnd->last_mp1 = mp1;
                wnd->last_mp2 = mp2;
                switch(msg)
                {
                case WM_KEYDOWN:
                        {
                        if (mp1 == VK_SHIFT)
                                wxSDown = TRUE;
                        else if (mp1 == VK_CONTROL)
                                wxCDown = TRUE;
                        // Avoid duplicate messages to OnChar
			else if ((mp1 != VK_ESCAPE) && (mp1 != VK_SPACE) &&
                                 (mp1 != VK_RETURN) && (mp1 != VK_BACK))
                                {
                                wnd->Char(MPARAM);
                                }
                        else break;
                        return 0;
                        }
                case WM_KEYUP:
                {
                        if (mp1 == VK_SHIFT)
                                wxSDown = FALSE;
                        else if (mp1 == VK_CONTROL)
                                wxCDown = FALSE;
                        else break;
                        return 0;
                }
                case WM_CHAR: // Always an ASCII character
                {
                        wnd->Char(mp1,TRUE);
                        return 0;
                        break;
                }
                default:
		return CallWindowProc(WNDPROCCAST wnd->oldTextProc, hWnd, message, wParam, lParam);
                }
        }
	return CallWindowProc(WNDPROCCAST wnd->oldTextProc, hWnd, message, wParam, lParam);
}
#endif

void wxTextWindow::OnChar(wxKeyEvent& event)
{
    BOOL CF,SF;
    HWND hWnd = GetHWND();
//        MPARAM mp1 = (MPARAM)event.keyCode;
    MPARAM mp2 = (MPARAM)1;
    MPARAM mp1UpDown = (MPARAM)event.keyCode;
    MPARAM mp2UpDown = (MPARAM)1; // 1 key (no repeats)
    MPARAM mp1Char = (MPARAM)event.keyCode;
    MPARAM mp2Char = (MPARAM)1; // 1 key (no repeats)
    Bool IsVirtual;
    int id = wxCharCodeWXToOS2((int)mp1UpDown, &IsVirtual);
    if(IsVirtual != 0)
    {
	mp1UpDown = (MPARAM)id;
	mp1Char = (MPARAM)id;
	switch (id) {
#if XXX
	case 46:
	    mp1UpDown = VK_DECIMAL;
	    break;
#endif
	default:
	    break;
	}
	mp2 += 0x41000000;
    }
    /*if (event.controlDown && mp1 > 96)    \\prawdopodobnie ktorys ze znakow <32
      mp1 -= 96;*/
    CF=SF=FALSE;
    if(event.controlDown != wxCDown)
    {
	if(event.controlDown)
	    WinPostMsg(hWnd,WX_KEYDOWN,(MPARAM)VK_CTRL,mp2UpDown);
	else
	    WinPostMsg(hWnd,WX_KEYUP,(MPARAM)VK_CTRL,mp2UpDown);
	CF=TRUE;
    }
    if(event.shiftDown!=wxSDown) {
	if(event.shiftDown)
	    WinPostMsg(hWnd,WX_KEYDOWN,(MPARAM)VK_SHIFT,mp2UpDown);
	else
	    WinPostMsg(hWnd,WX_KEYUP,(MPARAM)VK_SHIFT,mp2UpDown);
	SF=TRUE;
    }
    if (IsVirtual)
	WinPostMsg(hWnd,WX_KEYDOWN,mp1UpDown,mp2UpDown);
    if(!IsVirtual)
	WinPostMsg(hWnd,WX_CHAR,mp1Char,mp2Char);
    if (IsVirtual)
	WinPostMsg(hWnd,WX_KEYUP,mp1UpDown,mp2UpDown);
    if (SF)
	if(!event.shiftDown)
	    WinPostMsg(hWnd,WX_KEYDOWN,(MPARAM)VK_SHIFT,mp2UpDown);
	else
	    WinPostMsg(hWnd,WX_KEYUP,(MPARAM)VK_SHIFT,mp2UpDown);
    if (CF)
	if(!event.controlDown)
	    WinPostMsg(hWnd,WX_KEYDOWN,(MPARAM)VK_CTRL,mp2UpDown);
	else
	    WinPostMsg(hWnd,WX_KEYUP,(MPARAM)VK_CTRL,mp2UpDown);
    //CallWindowProc((int (pascal*)())wnd->oldTextProc, hWnd, last_msg, last_wparam, last_lparam);
    return;
}


Bool wxTextWindow::Create(wxWindow *parent, int x, int y, int width, int height,
                           long style, const char *name)
{
    TRACE("wxTextWindow::Create(parent=%#x, x=%d, y=%d, w=%d, h=%d, style=%#x, name='%s')", (int)parent, x, y, width, height, (int)style, name);
    SetName(name);
    window_parent = parent;
    file_name = NULL;
    insertionPoint = 0;
    windowStyle = style;

    wxWnd *cparent = NULL;
    if (parent)
	cparent = (wxWnd *)parent->handle;
    if (wxSubType(parent->__type, wxTYPE_PANEL))
	((wxPanel *)parent)->GetValidPosition(&x, &y);

    windows_id = (int)NewControlId();

    ULONG os2Style = MLS_BORDER | WS_TABSTOP | MLS_VSCROLL;
    if (windowStyle & wxREADONLY)
	os2Style |= MLS_READONLY;
    if (windowStyle & wxHSCROLL)
	os2Style |= MLS_HSCROLL;
//    if (windowStyle & wxBORDER)
//      msStyle |= WS_BORDER;

//  HWND hwndClient = cparent->GetClientHWND();
    HWND hwndClient = parent->GetHWND();
    TRACE("Creating MLE, parent hwnd=%#x, client hwnd=%#x", (int)parent->GetHWND(), (int)hwndClient);
    hwndTextWindow = WinCreateWindow(hwndClient, WC_MLE, NULL,
				     os2Style,
				     0, 0, 0, 0, hwndClient,
				     HWND_TOP, windows_id, NULL, NULL);
    TRACE("wxTextWindow::Create: Window created, parent=%#x, handle=%#x", (int)hwndClient, (int)hwndTextWindow);
	    
#ifdef MSW

    if (edit)
    {
      if (!wxTextWinList)
      {
        wxTextWinList=new wxList;
        WX_KEYDOWN=RegisterWindowMessage("WX_KEYDOWN");
        WX_CHAR=RegisterWindowMessage("WX_CHAR");
        WX_KEYUP=RegisterWindowMessage("WX_KEYUP");
        TextProc = (FIXWNDPROC) MakeProcInstance((FARPROC) wxTextProc,
    		                               globalHandle);
      }
/*

    if (OldTextProc == NULL) {
//      OldTextProc = (WNDPROC)GetWindowLong(edit,GWL_WNDPROC);
      TextProc = (WNDPROC) MakeProcInstance(wxTextProc,
                                               globalHandle);
      WX_KEYDOWN=RegisterWindowMessage("WX_KEYDOWN");
      WX_CHAR=RegisterWindowMessage("WX_CHAR");
      WX_KEYUP=RegisterWindowMessage("WX_KEYUP");
    }
*/
    oldTextProc = (FIXWNDPROC)GetWindowLong(edit,GWL_WNDPROC);

    // Defined in windowsx.h as a SetWindowLong.
    (void) SubclassWindow(hwndTextWindow, TextProc);
#else
      wxTextWinList=new wxList;
#endif
    wxTextWinList->Append((long)hwndTextWindow, this);
    
#if 0
    // Set tab stops every 4 (default is 8).. units in 1/4 characters!
    WORD wTabSpacing = 4 * 4;
    SendMessage(hwndTextWindow, EM_SETTABSTOPS, 1, (MPARAM)&wTabSpacing);

    // Initialize
//    SendMessage(hwndTextWindow, WM_SETTEXT, 0, (MPARAM)"");
    SetWindowText(hwndTextWindow, "");
#endif
    SetSize(x, y, width, height);

  if (parent) parent->AddChild(this);
  if (wxSubType(parent->__type, wxTYPE_PANEL))
    ((wxPanel *)parent)->AdvanceCursor(this);

  return TRUE;
}

wxTextWindow::~wxTextWindow(void)
{
    TRACE("wxTextWindow::~wxTextWindow() this=%#x wxWindow=%#x", this, (wxWindow *)this);
    if (wxTextWinList)
	wxTextWinList->DeleteObject(this);
    
    if (file_name)
	delete[] file_name;
    WinDestroyWindow(hwndTextWindow);
}

void wxTextWindow::SetFont(wxFont *the_font)
{
    TRACE("wxTextWindow::SetFont(the_font=%#x)", the_font);

    TRACE("wxTextWindow::SetFont(font=%#x)", font);
    TRACE("wxTextWindow::SetFont: GetFamilyString() => '%s'", the_font->GetFamilyString());
    TRACE("wxTextWindow::SetFont: GetFaceName() => '%s'", the_font->GetFaceName());
    TRACE("wxTextWindow::SetFont: GetStyleString() => '%s'", the_font->GetStyleString());
    TRACE("wxTextWindow::SetFont: GetWeightString() => '%s'", the_font->GetWeightString());

    font = the_font;
    if (font)
	wxSetWinFont(hwndTextWindow, font);
}

Bool wxTextWindow::LoadFile(char *file)
{
    if (!file || !FileExists(file))
	return FALSE;

    if (file_name)
	delete[] file_name;

    file_name = copystring(file);

    Clear();

  
#if 0
    int fd = open(file, O_RDONLY | O_BINARY);
    if (fd != -1) {
	struct stat sbuf;
	fstat(fd, &sbuf);
	char *buf = new char[sbuf.st_size];
	read(fd, buf, sbuf.st_size);
//	  WinSendMsg(hwndTextWindow, MLM_FORMAT, MLFIE_CFTEXT, 0);
	WinSendMsg(hwndTextWindow, MLM_SETIMPORTEXPORT, MPFROMP(buf), MPFROMLONG(sbuf.st_size));
	WinSendMsg(hwndTextWindow, MLM_DISABLEREFRESH, 0, 0);
	LONG lOffset = -1;
	WinSendMsg(hwndTextWindow, MLM_IMPORT, MPFROMP(&lOffset), MPFROMLONG(sbuf.st_size));
	WinSendMsg(hwndTextWindow, MLM_ENABLEREFRESH, 0, 0);
	WinSendMsg(hwndTextWindow, MLM_SETCHANGED, FALSE, 0);
	delete[] buf;
	return TRUE;
    }
	  
#else
    ifstream input(file, ios::nocreate | ios::in);

    if (!input.bad()) {
	WinSendMsg(hwndTextWindow, MLM_SETIMPORTEXPORT, MPFROMP(wxBuffer), MPFROMLONG(500));
	WinSendMsg(hwndTextWindow, MLM_DISABLEREFRESH, 0, 0);
	WinSendMsg(hwndTextWindow, MLM_FORMAT, (MPARAM)MLFIE_NOTRANS, 0);

	LONG lOffset = 0;
	while (!input.eof() && input.peek() != EOF) {
	    input.getline(wxBuffer, 500);
	    ULONG len = strlen(wxBuffer);
	    wxBuffer[len++] = '\n';
	    WinSendMsg(hwndTextWindow, MLM_IMPORT, MPFROMP(&lOffset), MPFROMLONG(len));
//	    lOffset++;
	}
	WinSendMsg(hwndTextWindow, MLM_ENABLEREFRESH, 0, 0);
	WinSendMsg(hwndTextWindow, MLM_SETCHANGED, FALSE, 0);
	return TRUE;
    }
#endif
    return FALSE;
}

// If file is null, try saved file name first
// Returns TRUE if succeeds.
Bool wxTextWindow::SaveFile(char *file)
{
  if (!file)
    file = file_name;
  if (!file)
    return FALSE;
  if (file_name) delete[] file_name;
  file_name = copystring(file);


#if 0
  ofstream output(file);

    // This will only save 64K max
    unsigned long nbytes = SendMessage(hwndTextWindow, WM_GETTEXTLENGTH, 0, 0);
    char *tmp_buffer = (char*)farmalloc(nbytes+1);
    SendMessage(hwndTextWindow, WM_GETTEXT, (MPARAM)(nbytes+1), (MPARAM)tmp_buffer);
    char *pstr = tmp_buffer;
    
    if (!output.bad())
    {
        // Convert \r\n to just \n
        while (*pstr)
        {
                if (*pstr != '\r')
                        output << *pstr;
                pstr++;
        }
    }

    farfree(tmp_buffer);
    SendMessage(hwndTextWindow, EM_SETMODIFY, FALSE, 0L);
#endif

  return FALSE;
}

void wxTextWindow::WriteText(char *text)
{
//  Synch();
    WinSendMsg(hwndTextWindow, MLM_INSERT, text, 0);
}

void wxTextWindow::SetSize(int x, int y, int w, int h, int sizeFlags)
{
    TRACE("wxTextWindow::SetSize(x=%d, y=%d, w=%d, h=%d, sizeFlags=%#x)", x, y, w, h, sizeFlags);
    MoveWindow(x, y, w, h, TRUE);
    GetEventHandler()->OnSize(w, h);
}

void wxTextWindow::Clear(void)
{
//  Synch();
    SetSelection(-1, -1);
    WinSendMsg(hwndTextWindow, MLM_CLEAR, 0, 0);
}

Bool wxTextWindow::Modified(void)
{
    return (Bool)WinSendMsg(hwndTextWindow, MLM_QUERYCHANGED, 0, 0);
}

// Makes 'unmodified'
void wxTextWindow::DiscardEdits(void)
{
    WinSendMsg(hwndTextWindow, MLM_SETCHANGED, FALSE, 0L);
}

char *wxTextWindow::GetContents(void)
{
//  Synch();
    LONG size = (LONG)WinSendMsg(hwndTextWindow, MLM_QUERYFORMATTEXTLENGTH, 0, (MPARAM)0xffffffff);
    if (size > (LONG)sizeof(wxBuffer))
	    size = sizeof(wxBuffer);
    WinSendMsg(hwndTextWindow, MLM_SETIMPORTEXPORT, MPFROMP(wxBuffer), MPFROMLONG(size));
    ULONG ulOffsetBegin = 0;
    ULONG ulLenMLE;
    WinSendMsg(hwndTextWindow, MLM_EXPORT, MPFROMP(&ulOffsetBegin), MPFROMP(&ulLenMLE));
    wxBuffer[ulLenMLE] = 0;
    return wxBuffer;
}

 
int wxTextWindow::GetNumberOfLines(void)
{
//  Synch();
    return (int)WinSendMsg(hwndTextWindow, MLM_QUERYLINECOUNT, 0, 0);
}

void wxTextWindow::SetInsertionPoint(long pos)
{
    WinSendMsg(hwndTextWindow, MLM_SETSEL, MPFROMLONG(pos), MPFROMLONG(pos));
}

void wxTextWindow::SetInsertionPointEnd(void)
{
  long pos = GetLastPosition();
  SetInsertionPoint(pos);
}

long wxTextWindow::GetInsertionPoint(void)
{
    return (long)WinSendMsg(hwndTextWindow, MLM_QUERYSEL, (MPARAM)MLFQS_CURSORSEL, 0);
}

long wxTextWindow::GetLastPosition(void)
{
    return (long)WinSendMsg(hwndTextWindow, MLM_QUERYTEXTLENGTH, 0, 0);
}

long wxTextWindow::XYToPosition(long x, long y)
{
    TRACE("wxTextWindow::XYToPosition(x=%ld, y=%ld)", x, y);
#if XXX
    HWND hWnd = GetHWND();
    
    // This gets the char index for the _beginning_ of this line
    int charIndex = (int)SendMessage(hWnd, EM_LINEINDEX, (MPARAM)y, (MPARAM)0);
    return (long)(x + charIndex);
#else
    return 0;
#endif
}

void wxTextWindow::PositionToXY(long pos, long *x, long *y)
{
    TRACE("wxTextWindow::PositionToXY(pos=%d, ...)", pos);
#if XXX
    HWND hWnd = GetHWND();

    // This gets the line number containing the character
    int lineNo = (int)SendMessage(hWnd, EM_LINEFROMCHAR, (MPARAM)pos, (MPARAM)0);
    // This gets the char index for the _beginning_ of this line
    int charIndex = (int)SendMessage(hWnd, EM_LINEINDEX, (MPARAM)lineNo, (MPARAM)0);
    // The X position must therefore be the different between pos and charIndex
    *x = (long)(pos - charIndex);
    *y = (long)lineNo;
#else
#endif
}

void wxTextWindow::ShowPosition(long pos)
{
#if XXX
    HWND hWnd = GetHWND();
    
    // To scroll to a position, we pass the number of lines and characters
    // to scroll *by*. This means that we need to:
    // (1) Find the line position of the current line.
    // (2) Find the line position of pos.
    // (3) Scroll by (pos - current).
    // For now, ignore the horizontal scrolling.

    // Is this where scrolling is relative to - the line containing the caret?
    // Or is the first visible line??? Try first visible line.
    int currentLineLineNo1 = (int)SendMessage(hWnd, EM_LINEFROMCHAR, (WPARAM)-1, (LPARAM)0L);

    int currentLineLineNo = (int)SendMessage(hWnd, EM_GETFIRSTVISIBLELINE, (WPARAM)0, (LPARAM)0L);

    int specifiedLineLineNo = (int)SendMessage(hWnd, EM_LINEFROMCHAR, (WPARAM)pos, (LPARAM)0L);
    
    int linesToScroll = specifiedLineLineNo - currentLineLineNo;

/*
    wxDebugMsg("Caret line: %d; Current visible line: %d; Specified line: %d; lines to scroll: %d\n",
      currentLineLineNo1, currentLineLineNo, specifiedLineLineNo, linesToScroll);
*/

    if (linesToScroll != 0)
      (void)SendMessage(hWnd, EM_LINESCROLL, (WPARAM)0, (LPARAM)MAKELPARAM(linesToScroll, 0));
#endif
}

int wxTextWindow::GetLineLength(long lineNo)
{
// Synch();
    long charIndex = (long)WinSendMsg(hwndTextWindow, MLM_CHARFROMLINE, MPFROMLONG(lineNo), 0);
    int len = (long)WinSendMsg(hwndTextWindow, MLM_QUERYLINELENGTH, MPFROMLONG(charIndex), 0);
    len += 2;			// <CR><LF>
    return len;
}

int wxTextWindow::GetLineText(long lineNo, char *buf)
{
    LONG charIndex = (LONG)WinSendMsg(hwndTextWindow, MLM_CHARFROMLINE, MPFROMLONG(lineNo), 0);
    ULONG noChars = (ULONG)WinSendMsg(hwndTextWindow, MLM_QUERYLINELENGTH, MPFROMLONG(charIndex), 0);
    WinSendMsg(hwndTextWindow, MLM_SETIMPORTEXPORT, MPFROMP(buf), MPFROMLONG(noChars));
    WinSendMsg(hwndTextWindow, MLM_EXPORT, MPFROMP(&charIndex), MPFROMP(&noChars));
    buf[noChars++] = '\r';
    buf[noChars++] = '\n';
    buf[noChars] = '\0';
    return noChars;
}

void wxTextWindow::Replace(long from, long to, char *value)
{
    SetSelection(from, to);
    WinSendMsg(hwndTextWindow, MLM_INSERT, value, 0);
}

void wxTextWindow::Remove(long from, long to)
{
    WinSendMsg(hwndTextWindow, MLM_DELETE, MPFROMLONG(from), MPFROMLONG(to - from));
}

void wxTextWindow::SetSelection(long from, long to)
{
    // if from and to are both -1, it means
    // (in wxWindows) that all text should be selected.
    // This translates into Windows convention
    if (from == -1 && to == -1) {
	    from = 0;
	    to = GetLastPosition();
    }
    WinSendMsg(hwndTextWindow, MLM_SETSEL, MPFROMLONG(to), MPFROMLONG(from));
}

void wxTextWindow::SetEditable(Bool editable)
{
    WinSendMsg(hwndTextWindow, MLM_SETREADONLY, (MPARAM)editable, MPVOID);
}

// Copy selection to clipboard
void wxTextWindow::Copy(void)
{
    WinSendMsg(hwndTextWindow, MLM_COPY, MPVOID, MPVOID);
//  Synch();
}

// Paste clipboard into text window
void wxTextWindow::Paste(void)
{
//  Synch();
    WinSendMsg(hwndTextWindow, MLM_PASTE, MPVOID, MPVOID);
}

// Copy selection to clipboard, then remove selection.
void wxTextWindow::Cut(void)
{
//  Synch();
    WinSendMsg(hwndTextWindow, MLM_CUT, MPVOID, MPVOID);
}

HWND wxTextWindow::GetHWND(void)
{
    return hwndTextWindow;
}
